package org.expeditee.agents;

import java.util.Collection;

import org.expeditee.gui.Frame;
import org.expeditee.gui.FrameGraphics;
import org.expeditee.gui.FrameIO;

public class SearchFramesetFast extends SearchAgent {
	private long _firstFrame = 1;
	private long _maxFrame = Integer.MAX_VALUE;
	
	public SearchFramesetFast(long firstFrame, long maxFrame) {
		_firstFrame = firstFrame;
		_maxFrame = maxFrame;
	}
	
	public SearchFramesetFast() {
		super();
	}

	@Override
	protected Frame process(Frame frame) {
		String path = frame.path;
		_frameCount = FrameIO.getLastNumber(frame.getName());
		for (long i = _firstFrame;i <= _maxFrame && i < _frameCount; i++) {
			if (_stop) {
				break;
			}
			String frameName = _startName + i;
			overwriteMessage("Searching " + frameName);
			Collection<String> found = FrameIO.searchFrame(frameName, _pattern, path);
			int size = found == null? 0 :found.size();
			if(size > 0){
				String repeats = size > 1? ("("+ size+ ")") : "";
				_results.addText(frameName + repeats, null, frameName, null, false);
				FrameGraphics.requestRefresh(true);
			}
		}
		_results.save();

		String resultFrameName = _results.getName();
		if (_clicked != null)
			_clicked.setLink(resultFrameName);

		return _results.getFirstFrame();
	}
}
