package org.expeditee.simple;

import java.text.NumberFormat;
import java.util.Observable;
import java.util.Observer;

import org.expeditee.gui.AttributeUtils;
import org.expeditee.gui.AttributeValuePair;
import org.expeditee.gui.Frame;
import org.expeditee.items.Text;
import org.nfunk.jep.JEP;
import org.nfunk.jep.Variable;

public class ExpediteeJEP extends JEP {
	Observer observer = null;
	
	public ExpediteeJEP() {
		super();
		addStandardFunctions();
		addStandardConstants();
		setImplicitMul(true);
		setAllowAssignment(true);
		setAllowUndeclared(true);
		resetObserver();
	}
	
	public void resetObserver() {
		observer = new Observer() {
			private String _attribute = "";

			public void update(Observable ob, Object o) {
				_attribute = ((Variable) o).getName();
			}

			@Override
			public String toString() {
				return _attribute;
			}
		};
		getSymbolTable().addObserver(observer);
		getSymbolTable().addObserverToExistingVariables(observer);
	}

	public String getResult() {
		Double result = getValue();
		if(result.isNaN()){
			return null;
		}		
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMinimumFractionDigits(0);
		nf.setMaximumFractionDigits(15);
		return observer.toString()+ ": " + nf.format(result);
	}

	public void addVariables(Frame frame) {
		if(frame == null)
			return;
		// Check for variables
		for (Text t : frame.getTextItems()) {
			AttributeValuePair avp = AttributeUtils.getPair(t.getText());
			if (avp != null) {
				addVariable(avp.getAttribute(), avp
						.getDoubleValue());
			}
		}
	}

	public String getNewVariable() {
		return observer.toString();
	}
}
